#ifndef __MACHINE_H__
#define __MACHINE_H__

#include "storage.h"

class Machine
{
protected:
   void Input(Storage & S);

public:
   // members of class
   Storage Memory;

   // constructor and destructor of class
   Machine(int s);
   ~Machine();

   // access to members of Memory
   int GetSize();

   // more elementary not virtually functions
   void Load(const char * Path);
   void Save(const char * Path);

   // virtual functions
   virtual void Reset();
   virtual void Run();
   virtual int IsHalted();
   virtual void Step();

   // from virtual functions derived functions
   void Run(Storage & S);
   int IsRunning();
};

#endif
