#ifndef __STORAGE_H__
#define __STORAGE_H__

class Storage
{
private:
   // friends of class
   friend class Register;

   // members of class
   int Size;
   unsigned char * Byte;

   // private modifications of Byte[]
   void FillFromArray(const unsigned char A[], int Length);
   void StoreToArray(unsigned char A[], int Length);

public:
   // constructor and destructor of class
   Storage(int s);
   ~Storage();

   // access to members of class
   int GetSize();

   // elementary funktions
   void Clear();
   void Load(const char * Path);
   void Save(const char * Path);

   // access to stored data
   unsigned char & operator[](int i);

   // comparison of data
   int operator==(Storage & S);
   int operator!=(Storage & S);
};

#endif
