#include <assert.h>
#include <limits.h>

#include "stdprj.h"
#include "test4.h"

#define RUNFLAG (Memory[0])
#define VCHAR1 (Memory[1])
#define VCHAR2 (Memory[2])

void Test4::Reset()
{
   // clear Memory
   Memory.Clear();

   // Test3 is halted after Reset()
   RUNFLAG = FALSE;
}

void Test4::Run()
{
   // Exit on error!
   assert(IsHalted());

   // set RUNFLAG
   RUNFLAG = TRUE;
}

int Test4::IsHalted()
{
   // test RUNFLAG
   return(!RUNFLAG);
}

void Test4::Step()
{
   // Exit on error!
   assert(IsRunning());

   // execute step
   VCHAR1++;

   // let Test4 run into an infinite loop
   // Exit on error!
   assert(IsRunning());
}
