#include <assert.h>
#include <limits.h>

#include "stdprj.h"
#include "test6.h"

#define RUNFLAG (Memory[0])
#define VCHAR1 (Memory[1])
#define VCHAR2 (Memory[2])

void Test6::Reset()
{
   // clear Memory
   Memory.Clear();

   // Test6 is halted after Reset()
   RUNFLAG = FALSE;
}

void Test6::Run()
{
   // Exit on error!
   assert(IsHalted());

   // set RUNFLAG
   RUNFLAG = TRUE;
}

int Test6::IsHalted()
{
   // test RUNFLAG
   return(!RUNFLAG);
}

void Test6::Step()
{
   // Exit on error!
   assert(IsRunning());

   // execute step
   if (VCHAR1 == UCHAR_MAX)
   {
      VCHAR2++;
   }
   VCHAR1++;

   // let Test6 run into an infinite loop
   // Exit on error!
   assert(IsRunning());
}
